"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
let NumberPickerComponent = class NumberPickerComponent {
    constructor() {
        this.onChange = new core_1.EventEmitter();
    }
    ngOnInit() {
        if (this.inputDisabled == null) {
            this.inputDisabled = false;
        }
        if (this.min == null) {
            this.min = 0;
        }
        if (this.max == null) {
            this.max = 100;
        }
        if (this.precision == null) {
            this.precision = 1;
        }
        if (this.step == null) {
            this.step = 1;
        }
        this.numberPicker = new forms_1.FormControl({ value: this.min, disabled: this.inputDisabled });
        this.numberPicker.registerOnChange(() => {
            this.onChange.emit(this.numberPicker.value);
        });
    }
    increaseValue() {
        var currentValue = this.numberPicker.value;
        if (currentValue < this.max) {
            currentValue = currentValue + this.step;
            if (this.precision != null) {
                currentValue = this.round(currentValue, this.precision);
            }
            this.numberPicker.setValue(currentValue);
        }
    }
    decreaseValue() {
        var currentValue = this.numberPicker.value;
        if (currentValue > this.min) {
            currentValue = currentValue - this.step;
            if (this.precision != null) {
                currentValue = this.round(currentValue, this.precision);
            }
            this.numberPicker.setValue(currentValue);
        }
    }
    round(value, precision) {
        let multiplier = Math.pow(10, precision || 0);
        return Math.round(value * multiplier) / multiplier;
    }
    getValue() {
        return this.numberPicker.value;
    }
};
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberPickerComponent.prototype, "min", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberPickerComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberPickerComponent.prototype, "step", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberPickerComponent.prototype, "precision", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberPickerComponent.prototype, "inputDisabled", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberPickerComponent.prototype, "onChange", void 0);
NumberPickerComponent = __decorate([
    core_1.Component({
        selector: 'angular2-number-picker',
        template: `
    <span class="input-group">  
      <div class="input-group-btn">
        <button class="btn btn-primary" (click)="decreaseValue()">-</button>
      </div>
      <input [formControl]="numberPicker" class="form-control" type="number" min="{{min}}" max="{{max}}" pattern="{{pattern}}"/>  
      <div class="input-group-btn">
        <button class="btn btn-primary" (click)="increaseValue()">+</button>
      </div>
    </span>
  `,
        styles: [`
    input[type=number]::-webkit-inner-spin-button, 
    input[type=number]::-webkit-outer-spin-button { 
      -webkit-appearance: none; 
      margin: 0; 
    }
    input[type=number] {
      text-align: center;
    }
  `]
    }),
    __metadata("design:paramtypes", [])
], NumberPickerComponent);
exports.NumberPickerComponent = NumberPickerComponent;
//# sourceMappingURL=number-picker.component.js.map